# Add-RASImageOptimizationWindowsComponent.md

## NAME

Add-RASImageOptimizationWindowsComponent

## SYNOPSIS

Adds Windows Custom Component.

## SYNTAX

\*\*Add-RASImageOptimizationWindowsComponent -[DefObjType](#defobjtype) {RDSDef | VDIDef | AVDSingleSessionDefaultSettings | AVDMultiSessionDefaultSettings | VDIGuestDef} \[[Aliases](#aliases-string) *(string)*] \[[ComponentName](#componentname-string) *(string)*] \[[DisplayName](#displayname-string) *(string)*] \[[SiteId](#siteid-string) *(uint)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

\*\*Add-RASImageOptimizationWindowsComponent \[[Id](#id-string)] *(uint)* -[ObjType](#objtype) {RDSHost | RDS | VDIHostPool | AVDHostPool | RDSTemplate | VDITemplate | AVDTemplate} \[[Aliases](#aliases-string) *(string)*] \[[ComponentName](#componentname-string) *(string)*] \[[DisplayName](#displayname-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

\*\*Add-RASImageOptimizationWindowsComponent \[-[InputObject](#inputobject)] *(*[*RASSerilazableObj*](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/rasserilazableobj.md)*)* \[[Aliases](#aliases-string) *(string)*] \[[ComponentName](#componentname-string) *(string)*] \[[DisplayName](#displayname-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

\*\*Add-RASImageOptimizationWindowsComponent \[[Name](#name-string)] *(string)* \[\[-[SiteId](#siteid-string)] *(uint)*] -[ObjType](#objtype) {RDSHost | RDS | VDIHostPool | AVDHostPool | RDSTemplate | VDITemplate | AVDTemplate} \[[Aliases](#aliases-string) *(string)*] \[[ComponentName](#componentname-string) *(string)*] \[[DisplayName](#displayname-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

## DESCRIPTION

Adds Windows Component to the following list.

## PARAMETERS

## Aliases (string)

```
        Required?                    false

        Position?                    named

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## DisplayName (string)

```
        Required?                    false

        Position?                    named

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## ComponentName (string)

```
        Required?                    false

        Position?                    named

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## Name (string)

The name or server for which to modify the Image Optimization settings.

```
        Required?                    true

        Position?                    0

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## SiteId (uint)

Site ID from which to modify the Image Optimization settings.

If the parameter is omitted, the Licensing Server site ID will be used.

```
        Required?                    false

        Position?                    1

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## Id (uint)

The ID of a server for which to modify the Image Optimization settings.

```
        Required?                    true

        Position?                    0

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## InputObject

([RASSerilazableObj](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/rasserilazableobj.md)) An object of type RDS, VDITemplate or VDIDesktop for which to modify the Image Optimization settings.

```
        Required?                    true

        Position?                    0

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## ObjType

([OptimizationServerObjType](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/optimizationserverobjtype.md)) The Object Type for which to modify the Image Optimization settings.

Possible values: RDSHost, RDS, VDIHostPool, AVDHostPool, RDSTemplate, VDITemplate, AVDTemplate

```
        Required?                    true

        Position?                    named

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## DefObjType ([ServerDefObjType](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/serverdefobjtype.md))

The Default Object Type for which to modify the Image Optimization settings.

Possible values: RDSDef, VDIDef, AVDSingleSessionDefaultSettings, AVDMultiSessionDefaultSettings, VDIGuestDef

```
        Required?                    true

        Position?                    named

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

(CommonParameters)

```
        This cmdlet supports the common parameters: Verbose, Debug,

        ErrorAction, ErrorVariable, WarningAction, WarningVariable,

        OutBuffer, PipelineVariable, and OutVariable. For more information, see 

        about_CommonParameters documentation. 
```

## INPUTS

-none-

## OUTPUTS

-none-

## EXAMPLES

\*\*---------- EXAMPLE 1 ----------

Add-RASImageOptimizationWindowsComponent -Id 30 -ObjType RDS -DisplayName Name -Aliases alias -ComponentName Component Name

Adds the Windows Custom Component to the object type RDS.

## RELATED LINKS

* [Remove-RASImageOptimizationWindowsComponent](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/commands/remove-rasimageoptimizationwindowscomponent.md)
* [Get-RASImageOptimizationWindowsComponent](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/commands/get-rasimageoptimizationwindowscomponent.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.parallels.com/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/commands/add-rasimageoptimizationwindowscomponent.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
